# encoding: UTF-8
module TransferHelper

 ### specific helpers for transfer cells ####
  def html_cell_actions(transfer)
    link_to image_tag('/images/icon_edit.gif', :alt=>'E'),
      edit_transfer_path(transfer.id, pow_account_id: @account.andand.id )
  end
  def html_cell_actions_us(transfer)
    ' '
  end
  def html_cell_actions_us_edit(transfer)
    link_to 'edit', :action => 'edit_us', :controller => 'transfers', :id => transfer.id
  end
  def html_cell_actions_us_reconcile(transfer)
    link_to transfer.reconciled ? 'unrec.' : 'reconcile',
       reconcile_transfer_path(transfer), :method=> :post, :remote => true, 
         :class => 'reconcile_link', :pow_account_id => @account.id
#        :method => :get,
#        :url => {:action => 'reconcile', :controller => 'transfers',
#        :id => transfer.id, :pow_account_id => @account.id },
#        :html => {:class => 'reconcile_link'},
#        :remote => true
  end
  def html_cell_actions_us_edit_reconcile(transfer)
    html_cell_actions_us_edit(transfer) + ' ' + html_cell_actions_us_reconcile(transfer)
  end
  def html_cell_toggle_select(transfer)
    link_to (transfer.selected? ? '&#x2611;' : '&#x2610;').html_safe, 
        toggle_selected_transfer_path(transfer),  :method => :post, :remote => true, :class => 'selected_link'
  end
  def html_cell_documents_links(transfer)
    transfer.htmlfilenames.defaults_to('&nbsp;'.html_safe)
  end
  def html_cell_documents_urls(transfer)
    transfer.documents.collect(&:url).join(', ').defaults_to('&nbsp;'.html_safe)
  end
  def html_cell_documents_icons(transfer)
    ([
      link_to(image_tag('/images/icon_base_pdf.gif', :alt=>'B'), transfer_url(transfer,:pdf))
     ]+
     transfer.documents.collect{ |d|
      link_to image_tag(d.icon_path, :alt=>'D'), d.url, {:title=> h(d.filename.to_s)}
    }).join.tap { |s|
      s = "<span style=\"white-space:nowrap\">#{s}</span>".html_safe unless s.blank?
    }.html_safe
  end
  def html_cell_documents_icons_dropable(transfer)
    html = (
      [ link_to(image_tag('/images/icon_base_pdf.gif', :alt=>'B'), transfer_url(transfer,:pdf)) ]+
      transfer.documents.collect{ |d| link_to image_tag(d.icon_path, :alt=>'D'), d.url, {:title=> h(d.filename.to_s)}}
    ).join
    
    html2 = "<span id=\"dropzone_#{transfer.id}\" class=\"fade dropzone\">#{html}</span>".html_safe 
    return html2 +  
    "<script>
      $(function () {
        $('#dropzone_#{transfer.id}').fileupload(
          'option', {
            dropZone: '#dropzone_#{transfer.id}',
            url: '/transfers/#{transfer.id}'
          }
        );
      });
     </script>".html_safe
  end
  def html_cell_datum_seq(transfer)
    datum = transfer.datum.andand.strftime('<span>%d.%m</span>.%y').andand.gsub(/(?<=^<span>[0-9][0-9][.])0|(?<=^^<span>)0/,'')
    if not(transfer.datum2.nil?)
      datum += " (#{transfer.datum2.strftime('%-d.%-m.%y')})"
    end
    "<span title=\"#{transfer.seq}\">#{datum}</span>".html_safe
  end
  def html_cell_datumdva(transfer)
    transfer.datum2.strftime('%Y-%m-%d').html_safe
  end
  def html_cell_datum_cs(transfer)
    transfer.datum.strftime('%-d.%-m.%Y').html_safe
  end
  def html_cell_datum_iso(transfer)
    datum = transfer.datum.strftime('%Y-<span>%m-%d</span>')
    if not(transfer.datum2.nil?)
      datum += "(#{transfer.datum2.strftime('%Y-%m-%d')})"
    end
    "<span title=\"#{h transfer.seq}\">#{datum}</span>".html_safe
  end
  def html_cell_michail_datum_iso(transfer)
    unless transfer.datum2.nil?
      datum = transfer.datum2.strftime('%y-<span>%m-%d</span>') + transfer.datum.andand.strftime('&nbsp;(%m-%d)')
    else
      datum = transfer.datum.strftime('<span>N/A</span> (%Y-<span>%m-%d</span>)')
    end
    "<span title=\"#{h transfer.seq}/#{transfer.datum}\">#{datum}</span>&nbsp;".html_safe
  end
  def html_cell_updated_at(transfer)
    transfer.updated_at ||  'N/A'
  end
  def html_cell_seq(transfer)
    "<span title=\"#{h transfer.seq}\">#{transfer.seq}</span>".html_safe
  end
  def html_cell_seq_clone_link(transfer)
    klony = transfer.existing_clones
    if klony.empty?
      h(transfer.seq)
    else
      '<u>' + 
        ( klony.collect { |klon| 
            link_to h(transfer.seq) || 'link', :action=>'edit', :controller=>'transfers', :id=>klon.id
          }.join(', ') 
        ) + 
      '</u>'
    end.html_safe
  end
  def html_cell_popis_vendor(transfer)
    r = transfer.popis.to_s
    if  ((not transfer.vendor.nil?) and (not transfer.vendor.empty?))
      r << " (#{transfer.vendor.to_s})"
    end
    r.html_safe
  end
  def html_cell_popis_vendor_link(transfer)
    raise transfer.inspect if transfer.popis.nil?
    r = h(transfer.popis.html_safe)  # BASTL
    if  ((not transfer.vendor.nil?) and (not transfer.vendor.empty?))
      if transfer.partner.nil?
        r << (' ('+(link_to transfer.vendor.html_safe, {:controller=>'partners', :action => 'new', 'partner[nazev]'=>transfer.vendor.to_s}, {:class=>'new'})+')').html_safe # BASTL
      else
        r << (' ('+(link_to transfer.partner.nazev.html_safe, :controller=>'partners', :action => 'show', :id1=> transfer.partner.id1, :id2=>transfer.partner.id2)+')').html_safe # BASTL
      end
    end
    r.html_safe
  end
  def html_cell_amount_rich(transfer)
    richformat(transfer.amount)
  end
  def html_cell_quasiUSD_amount_rich(transfer)
    if transfer.id_account_from=='9a9726a4-f5b6-11dc-85fa-0013d4bc1a7d' 
      richformat(transfer.amountQuasiUSD)
    else
      richformat(transfer.amount)
    end
  end
  def html_cell_star(transfer) # star if there is some note
    note = transfer.michailed ? 'Sent to Michail.' : ''
    note += (not transfer.account_from.andand.most_specific?) ? 'From account can be more specific.' : ''
    if not note.empty?
      "<span title=\"#{note}\">*</span>".html_safe
    else
      ''.html_safe
    end
  end

  def html_cell_hash_reconciled(transfer) # star if there is some note
    if transfer.reconciled
      "<span title=\"reconciled\">#</span>".html_safe
    else
      ''.html_safe
    end
  end

  def html_cell_balance_rich(transfer)
    r = richformat(@balance)
    if @balance.negative?
      r = "<span style=\"color:red\">#{h r}</span>".html_safe
    end
    r
  end

  def html_cell_balance_out_rich(transfer)
    r = richformat(@balance_out)
    if @balance.negative?
      r = "<span style=\"color:red\">#{h r}</span>".html_safe
    end
    r
  end

  def html_cell_balance_diff(transfer)
    richformat(@balance-@balance_out)
  end

  def html_cell_account_to(transfer)
    transfer.account_to.andand.popis
  end

  def html_cell_account_to_seqofic(transfer)
    res = transfer.account_to.andand.seqofic
    res = '??' if res.blank?
    return res
  end
  def html_cell_account_from_seqofic(transfer)
    transfer.account_from.andand.seqofic
  end

  def html_cell_account_to_link(transfer)
    action = 'show'
    popis =
      if (@subaccounts.nil? or not @subaccounts.include?(transfer.account_to) )
        transfer.account_to.andand.popis
      else
        ((transfer.account_to == @account) ? '&#9788;' : '/&#9788;').html_safe
      end
    link_to popis.andand.html_safe, transfer.account_to, { :title => h(transfer.account_to.andand.popis) }
  end

  def html_cell_account_to_link_small(transfer)
    html_cell_account_to_link(transfer)
  end

  def html_cell_owner_link(transfer)
    popis = transfer.owner.andand.popis
    link_to popis, {:action=>'show', :controller=>'accounts', :id=> transfer.owner}, { :title => h(popis) }
  end

  def html_cell_owner_link_small(transfer)
    html_cell_owner_link(transfer)
  end
  
  def html_cell_account_from(transfer)
    link_to transfer.account_from.popis
  end

  def html_cell_account_from_link(transfer)
    subaccounts = @subaccounts.nil? ? (@account.andand.subaccounts) : @subaccounts  # @subaccounts je definovano kvuli rychlosti pokud ne, tak ho doplnime
    popis =
      if (@account.nil? or not subaccounts.include?(transfer.account_from) )
        transfer.account_from.andand.popis
      else
        ((transfer.account_from == @account) ? '&#9788;' : '/&#9788;').html_safe
      end
    (link_to popis, transfer.account_from, { :title => h(transfer.account_from.andand.popis) })
  end

  def html_cell_account_from_link_small(transfer)
    html_cell_account_from_link(transfer)
  end

  def html_cell_accounts(transfer)
    html_cell_account_from_link(transfer) + ' → '.html_safe + html_cell_account_to_link(transfer)
  end
  def html_cell_my_account(transfer)
    transfer.my_account.popis
  end
  def html_cell_edit_popis(transfer)
    "<b>#{transfer.popis}<b>"
  end  
  
  def html_cell_my_amount(transfer)
    transfer.my_amount.to_s
  end
  def html_cell_my_amount_currency(transfer)
    if transfer.my_amount.length != 1 
      '?ERR?'
    else
      transfer.my_amount.keys.first
    end
  end
  def html_cell_my_amount_value(transfer)
    if transfer.my_amount.length != 1 
      '?ERR?'
    else
      (-transfer.my_amount.values.first.to_f).to_s.gsub(/\./,',')
    end
  end
  def html_cell_amount_currencies(transfer)
    transfer.amount.keys.join(',')
  end
  def html_cell_amount_value_or_amount(transfer)
    if transfer.amount.length == 1
#       transfer.amount.values.first.to_f.to_s.gsub(/\./,',')
      ("%g" % ("%.2f" % transfer.amount.values.first)).gsub(/\./,',')
    else
      transfer.amount.to_s
    end
  end
  def html_cell_my_amount_value_or_amount(transfer)
    if transfer.my_amount.length == 1
      ("%.2f" % transfer.my_amount.values.first).gsub(/\./,',').gsub(/,00/,'')
#       ("%g" % ("%.2f" % transfer.my_amount.values.first)).gsub(/\./,',')
    else
      (transfer.my_amount).to_s
    end
  end
  def html_cell_foreign_account(transfer)
    transfer.my_other.popis
  end
  def html_cell_flipping_arrow(transfer)
    transfer.amount.negative? ? '←': '→'
  end
  def html_cell_rarrow(transfer)
    '→'
  end
  def html_cell_dph(transfer)
    if transfer.popis.to_s.match(/\[DPH\s*(.*)\]/) 
      $1
    else
      ''
    end
  end
  def html_cell_bank(transfer)
    ''
  end
  def html_cell_poradi(transfer)
    @counter
  end
  def html_cell_blank(transfer)
    ''
  end
  def html_cell_line_number(transfer,balance,counter)
    "#{counter})"
  end
  def html_cell_ids(transfer)
    [transfer.id[0..7], transfer.seq, transfer.seq2].reject{|x| x.blank?}.join (' / ')
  end
  def html_cell_tag_list(transfer)
    transfer.tag_list
  end
  def html_cell_tag_links(transfer)
    transfer.tags.map{|tag| link_to tag.nazev, tag }.join(', ')
  end
  def html_cell_epoch_brief(transfer);           transfer.epoch.name  end
  def html_cell_epoch_brief_link(transfer);      link_to transfer.epoch.name, transfer.epoch end
  def html_cell_epoch(transfer);      transfer.epoch.description end
  def html_cell_epoch_link(transfer); link_to  transfer.epoch end

 ### general helpers for transfer tables ###
  def html_cell(column,transfer,balance,counter)
    "<td #{column.class_tag}>#{html_cell_value(column,transfer,balance,counter)}</td>".html_safe
  end
  def html_cell_value(column,transfer,balance,counter)
    if respond_to?(method_name = "html_cell_#{column.id}")
      case method(method_name).arity
        when 1 then send(method_name,transfer)
        when 2 then send(method_name,transfer,balance)
        when 3 then send(method_name,transfer,balance,counter)
      end
    else
      begin
        transfer.send(column.id)
      rescue
        '?ERR?'
      end
    end
  end
  def html_header(column)
    if column.id == 'toggle_select'
      "<th #{column.class_tag}>"+
      (link_to_function '&#x2680;'.html_safe,
         "$('tbody .col_toggle_select a').trigger('click')") +
      "</th>"
    else
      "<th #{column.class_tag}>#{sort_link(column.label_or_nbsp,column.sort_column)}</th>"
    end.html_safe
  end

 ### other helpers ######
  def sort_link(title, column, options = {})
    condition = options[:unless] if options.has_key?(:unless)
    sort_dir = params[:d] == 'up' ? 'down' : 'up'
    if params[:d] and (params[:c] == column)
      title += (params[:d] == 'up') ? '⇣' : '⇡'
    end
    link_to_unless condition, title, request.parameters.merge( {:c => column, :d => sort_dir}), options[:html_options]
  end
  def hide_currency_css
    '<style type="text/css"> .curr {display: none} </style>'.html_safe
  end
  def table_tag_for(columns)
    "<table cols=\"#{ columns[0].length }\">".html_safe
  end
  def more_columns?(columns)
    columns.size > 1
  end
  def richformat(amount)
    amount.andand.to_s(:with_html => true, :delimiter=>'&nbsp;', :force_zeros=>false, :show_currency=>'always') # BASTL
  end
  def macroCSOB(transfers, options={})    
    waitsec = options[:waitsec] || 1    # jak dlouho čekat na místech kde bývá server pomalý
    if options[:login]
      @macroCSOB = "
      VERSION BUILD=8820413 RECORDER=FX
TAB T=1
URL GOTO=http://prague.sod.ncsu.edu/transfers/mass_pay_CSOB
TAB OPEN
TAB T=2
URL GOTO=https://ib24.csob.cz/
FRAME NAME=\"main\"
EVENTS TYPE=KEYPRESS SELECTOR=\"#txtIPD\" CHARS=\"20939410\"
EVENT TYPE=CLICK SELECTOR=\"#txtPNP\" BUTTON=0
SET !ENCRYPTION NO
EVENTS TYPE=KEYPRESS SELECTOR=\"#txtPNP\" CHARS=\"14270\"
EVENT TYPE=CLICK SELECTOR=\"#btnIbIppid\" BUTTON=0       
      ".html_safe
    else
      @macroCSOB = "
        VERSION BUILD=8300326 RECORDER=GORNUCTO
        TAB T=2
        FRAME NAME=\"main\"
      ".html_safe
    end
    i=1
    if !transfers.empty? and options[:login]
      @macroCSOB += "
        WAIT SECONDS=#{waitsec}
      ".html_safe
    end
    if !transfers.empty?
      @macroCSOB += "
        TAG POS=1 TYPE=SPAN ATTR=TXT:Favourites
        TAG POS=1 TYPE=A ATTR=ID:ctl00_mnuLeftMenu_mnuLeftMenu_3130M2M4F
        WAIT SECONDS=2
      ".html_safe
    end
    for transfer in transfers 
      i=i+1
      @linestartCSOB = 'TAG POS=1 TYPE=INPUT:TEXT FORM=ID:aspnetForm ATTR=ID:ctl00_formContent_BulkPaymentOrder_Form1_IBAuth1_aboGrd_grdBulkOrder_ctl'+ ('%02d' % i)
      @macroCSOB += "
        #{@linestartCSOB}_RecipientAccountNumber_txtAntenumber CONTENT=#{transfer.cislouctu_prefix}
        #{@linestartCSOB}_RecipientAccountNumber_txtAccount CONTENT=#{transfer.cislouctu_zaklad }
        #{@linestartCSOB}_chKodBankaProti CONTENT=#{transfer.cislouctu_banka}
        #{@linestartCSOB}_nCastka CONTENT=#{h transfer.amount.onlyCZK? ? transfer.amount['CZK'] : transfer.amount}
        #{@linestartCSOB}_chVS CONTENT=#{/VS:?\s*(\d*)/ =~ transfer.popis ? h($1) : ''}
        #{@linestartCSOB}_nKS CONTENT=#{/KS:?\s*(\d*)/ =~ transfer.popis ? h($1) : ''}
        #{@linestartCSOB}_nSS CONTENT=#{/SS:?\s*(\d*)/ =~ transfer.popis ? h($1) : ''}
        #{@linestartCSOB}_vchPoleAV1 CONTENT=#{transfer.popis.gsub(' ','<SP>'.html_safe)}
      ".html_safe
    end
    @macroCSOB
  end
  def macrolinkCSOB(transfers, options={})
    "javascript:(function() {try{var e_m64 = &quot;#{Base64.encode64(macroCSOB(transfers, options)).html_safe}&quot;, n64 = &quot;cHJvbXB0LmlpbQ==&quot;;if(!/^(?:chrome|https?|file)/.test(location)){alert(&quot;iMacros: Open webpage to run a macro.&quot;);return;}var macro = {};macro.source = decodeURIComponent(atob(e_m64));macro.name = decodeURIComponent(atob(n64));var evt = document.createEvent(&quot;CustomEvent&quot;);evt.initCustomEvent(&quot;iMacrosRunMacro&quot;, true, true, macro);window.dispatchEvent(evt);}catch(e){alert(&quot;iMacros Bookmarklet error: &quot;+e.toString());}}) ();".html_safe
  end
  def macrolinkRB(account, transfers, options={})
    require "base64"
    @macroRB = "
      VERSION BUILD=7031111 RECORDER=GORNUCTO
    ".html_safe
    if (account == :CBG)
      if options[:login]
        @macroRB += "
          TAB CLOSEALLOTHERS
          TAB OPEN
          TAB T=2
          URL GOTO=http://rb.cz/
          TAG POS=1 TYPE=A ATTR=TXT:Mobilní<SP>klíč

          WAIT SECONDS=2
          FRAME F=12
          TAG POS=1 TYPE=INPUT:TEXT FORM=NAME:Login ATTR=NAME:a_username CONTENT=777852582
          ONDIALOG POS=1 BUTTON=OK CONTENT=
          TAG POS=1 TYPE=IMG ATTR=SRC:https://klient1.rb.cz/Images/CZ/b_authcode.jpg

          PROMPT Vložte<SP>číselný<SP>kód<SP>který<SP>přijde<SP>na<SP>mobil !VAR1
          TAG POS=1 TYPE=INPUT:TEXT FORM=NAME:Login ATTR=NAME:a_userpassword CONTENT={{!VAR1}}
          SET !ENCRYPTION NO
          TAG POS=1 TYPE=INPUT:PASSWORD FORM=NAME:Login ATTR=NAME:a_smspin CONTENT=5553
          TAG POS=1 TYPE=IMG ATTR=SRC:https://klient1.rb.cz/Images/CZ/b_ok.jpg
          ' WAIT SECONDS=2
        ".html_safe
      else
        @macroRB += "
          TAB T=2
        ".html_safe
      end
      @macroRB += "
        FRAME NAME=\"MainMenu\"
        TAG POS=1 TYPE=TD ATTR=TXT:Hromadná<SP>platba
        ' vyplnit udaje
        ' WAIT SECONDS=2
        FRAME NAME=\"Main\"
      ".html_safe
      i=-1
      for transfer in transfers
        i = i + 1
        @linestartRB = 'TAG POS=1 TYPE=INPUT:TEXT FORM=NAME:NewCollPayTrans ATTR=NAME:'.html_safe
        @macroRB += "
          #{@linestartRB}PrefixAccNumber#{i} CONTENT=#{transfer.cislouctu_prefix}
          #{@linestartRB}ContraAccNumber#{i} CONTENT=#{transfer.cislouctu_zaklad}
          #{@linestartRB}ContraBankCode#{i} CONTENT=#{transfer.cislouctu_banka}
          #{@linestartRB}Amount#{i} CONTENT=#{('%.2f' % (transfer.amount.onlyCZK? ? transfer.amount['CZK'] : transfer.amount)).sub(/\./,',')}
          #{@linestartRB}VarSymbol#{i} CONTENT=#{/VS:?\s*(\d*)/ =~ transfer.popis ? $1 : ''}
          #{@linestartRB}ConstSymbol#{i} CONTENT=#{/KS:?\s*(\d*)/ =~ transfer.popis ? $1 : ''}
          #{@linestartRB}SpecSymbol#{i} CONTENT=#{/SS:?\s*(\d*)/ =~ transfer.popis ? $1 : ''}
          #{@linestartRB}MyMsg#{i} CONTENT=#{(h transfer.popis).gsub(' ','<SP>'.html_safe)}
        ".html_safe
      end
      return "http://run.imacros.net/?code=#{Base64.encode64(@macroRB)}".html_safe
    else
      return ''.html_safe
    end
  end

  class TransferTable < BlockHelpers::Base
    def initialize(columns, options={})
      @table_columns = prepare_columns(columns)
      @table_balance = options[:starting_balance]
      @balance ||= Hash.new()
    end
    def prepare_columns(columns)
      if columns == []
        [[]]
      elsif columns[0].class == Array
        columns
      else
        [columns]
      end
    end
    def display(body)
      if params[:format] == 'xml'
        %(
          <SeznamPokDokl>
            #{body}
          </SeznamPokDokl>
        )
      else
        %(
<div id="transfers">
<table cols="#{ @table_columns[0].length }">
  #{body}
</table>
</div>
        )
      end.html_safe
    end

    def header(starting_balance=Hash.new())
      if !@table_balance.nil? and !@table_balance.zero?
        @starting_balance_column = @table_columns[0].length - 1
        @table_columns[0].each_index { |index|
          if @table_columns[0][index].id == 'balance_rich'
            @starting_balance_column = index
          end
        }
        render :partial => 'transfers/table_header',
          :locals =>{:columns => @table_columns, :starting_balance => @table_balance, :starting_balance_column => @starting_balance_column}
      else
        render :partial => 'transfers/table_header', :locals =>{:columns => @table_columns}
      end
    end

    def body(transfers, options={})
      options.reverse_merge! :add_reconciled_class=>false
      options.reverse_merge! :add_highlighted_class=>true
      render :partial => 'transfers/table_row', :collection => transfers,
             :locals =>{:columns => @table_columns, :options=>options}
    end
  end

  def columns_from_params_with_default(*default)
    
    # normalize so default is array of arrays of Column objects
    if !default.first.is_a?(Array) # structure too shallow
      default = [default]
    elsif default.first.first.is_a?(Array) # structure too deep
      raise "Wrong structure od default columns argument in columns_from_params_with_default method" if default.size!=1
      default = default.first
    else
      # fine
    end
    
    # turn column names (Strings) into Columns
    unless default.first.first.is_a?(Column)
      default = Column.by_name(default)
    end

    # modify default by various params user settings
    if params[:columns_set]=='trinity'
      default = [Column.by_name('datumdva','datum_cs','popis','my_amount_currency','my_amount_value','balance_rich','documents_links' )]
    end  
    if params[:columns].nil? 
      default[0] += Column.by_name(params[:add_columns].to_s.split(','))
      return default
    else
      return [Column.by_name(params[:columns].split(','))]
    end
  end
  
  def giant_pdf_with_documents_for(transfers)
    tmpdir = Dir.mktmpdir; 
    tmpdir = '/tmp/felicia'
    resultfilename = "#{tmpdir}/reconciliation-documents.pdf"
    script = "cd #{tmpdir}; "; final_join_args = ''
    
    # generate individual pdfs and gather arguments for final assembling command
    transfers.each_with_index do |transfer,index|
      if params[:without_frontpages]
        if params[:annotate]
          annotation = params[:annotate].gsub(/\d+/){|m| m.to_i+index }.gsub('@','#')
          absdoclist = transfer.documents.map{|doc| doc.absolute_path}
          script += transfer.documents.map{|doc| "convert -density 200 #{doc.absolute_path} -fill white -undercolor '#00000080' -pointsize 17 -gravity NorthEast -annotate +60+60 '  #{annotation}  ' #{doc.filename}; "}.join
          final_join_args += transfer.documents.map{|doc| "#{doc.filename} "}.join
        else
          absdoclist = transfer.documents.map{|doc| doc.absolute_path}.join(' ')
          final_join_args += absdoclist+' '
        end
      else
        absdoclist = transfer.documents.map{|doc| doc.absolute_path}.join(' ')
        script += "wget #{transfer_url(transfer.id, :format=>'pdf')} --http-user=gorn --http-password=gorn1458; "
        final_join_args += "#{transfer.id}.pdf #{absdoclist} "
      end
    end

    # initialize logger
    logfilepath = Rails.root.join('log','debug.log')
    logfile = File.open(logfilepath, File::WRONLY | File::APPEND | File::CREAT)
    log = Logger.new(logfile,'a')

    # final assemble and run the script
    script += "pdftk #{final_join_args} cat output #{resultfilename} >> #{logfilepath}"
    log.debug("> Going to generate giant pdf with command:\n#{script}\n> Output of command:\n")
    `#{script}`
    
    send_file(resultfilename, :type => "application/pdf", :filename=>"reconciliation-documents.pdf",  :x_sendfile=>true, :disposition => 'inline')
  end
  
  def giant_zip_with_documents_for(transfers)
    if !transfers.blank?
      filename = "reconciliation-documents.zip"
      t = Tempfile.new("ucto-#{filename}-#{Time.now}")
      Zip::ZipOutputStream.open(t.path) do |z|
        transfers.each do |transfer|
          # generovaný dokument
          z.put_next_entry(transfer.id+'.pdf')
          z.print PDFKit.new(transfer_url(transfer.id, :format=>'pdf')).to_pdf
        
          # scanované dokumenty
          transfer.documents.each do |document|
            title = document.filename
            z.put_next_entry(title)
            z.print IO.read(document.absolute_path)
          end
        end
      end
      send_file t.path, :type => 'application/zip',
                        :disposition => 'attachment',
                        :filename => filename
      t.close
    end
  end
end

class Column

  @@columns = {
    'account_from'      => { :label=> ['z','from'], :sort_by=>'account_from.seq'},
    'account_from_link' => { :label=> ['z','from'], :sort_by=>'account_from.seq'},
    'account_from_link_small'=>{:label=>['z','from'], :sort_by=>'account_from.seq', :class=>'smaller'},
    'account_from_seqofic'=> { :label=> ['z','from'], :sort_by=>'account_from.seq', :class=>'smaller', :width=>100},
    'account_to'        => { :label=> ['do','to'], :sort_by=>'account_to.seq'},
    'account_to_link'   => { :label=> ['do','to'], :sort_by=>'account_to.seq'},
    'account_to_link_small'=>{:label=>['do','to'], :sort_by=>'account_to.seq', :class=>'smaller', :width=>160},
    'account_to_seqofic'=> { :label=> ['č.účtu','wolfpack code suggestion'], :sort_by=>'account_to.seq', :class=>'smaller', :width=>100},
    'account_to'        => { :label=> ['do','to'], :sort_by=>'account_to.seq'},
    'epoch_brief'       => { :label=> ['období','epoch'], :sort_by=>'epoch.starts_at'},
    'epoch_brief_link'  => { :label=> ['období','epoch'], :sort_by=>'epoch.starts_at'},
    'epoch'             => { :label=> ['období','epoch'], :sort_by=>'epoch.starts_at'},
    'epoch_link'        => { :label=> ['období','epoch'], :sort_by=>'epoch.starts_at'},
    'owner_link'        => { :label=> ['majitel','owner'], :sort_by=>'owner.seq'},
    'owner_link_small'  => { :label=> ['majitel','owner'], :sort_by=>'owner.seq', :class=>'smaller', :width=>160},

    'accounts'          => { :label=> ['z/do','from/to'], :sort_by=>'account_from.seq'},
    'actions'           => { :label=> ['','']},
    'actions_us'        => { :label=> ['',''], :class=>'small', :width=>40},
    'actions_us_edit'   => { :label=> ['',''], :class=>'small', :width=>40},
    'actions_us_reconcile'=>{:label=> ['',''], :class=>'small', :width=>40},
    'actions_us_edit_reconcile'=> { :label=> ['',''], :class=>'small', :width=>40},
    'dph'               => { :label=> ['DPH','VAT'], :class=>'alignright', :width=>50},
    'amount'            => { :label=> ['částka','amount'], :class=>'alignright', :sort_by=>'CONVERT(transfers.amount,DECIMAL)'},
    'amount_rich'       => { :label=> ['částka','amount'], :class=>'alignright', :sort_by=>'CONVERT(transfers.amount,DECIMAL)', :width=>80},
    'quasiUSD_amount_rich'=>{:label=> ['částka','amount'], :class=>'alignright', :sort_by=>'transfers.amount', :width=>80},
    'balance_rich'      => { :label=> ['zůstatek','balance'], :class=>'alignright'},
    'balance_out_rich'  => { :label=> ['zůstatek ven','balance out'], :class=>'alignright'},
    'balance_diff'      => { :label=> ['zůstatek ven','balance out'], :class=>'alignright'},
    'blank'             => { :label=> ['','']},
    'id'             => { :label=> ['id','id'], :class=>'dim', :width=>'*'},
    'ids'             => { :label=> ['ids','ids'], :class=>'dim', :width=>'*'},
    'datum'             => { :label=> ['datum','date'], :class=>'dim', :width=>75},
    'datum_cs'          => { :label=> ['datum','date'], :class=>'dim', :width=>75,  :class=>'alignright'},
    'datumdva'          => { :label=> ['datum2','date2'], :class=>'dim', :width=>75, :sort_by=>'datum2'},
    'datum_iso'         => { :label=> ['datum','date'], :class=>'dim', :sort_by=>'transfers.datum,transfers.seq,transfers.popis', :width=>95},
    'datum_seq'         => { :label=> ['datum','date'], :class=>'dim', :sort_by=>'transfers.datum,transfers.seq,transfers.popis', :width=>75},
    'updated_at' => { :label=> ['změněno','changed'], :sort_by=>'transfers.updated_at,transfers.datum,transfers.seq', :width=>75},
    'michail_datum_iso' => { :label=> ['dat.vlož.','reimb.date'], :class=>'dim', :sort_by=>'transfers.datum,transfers.seq,transfers.popis', :width=>225},
    'documents_icons'   => { :label=> ['<img src="/images/icon_attachment.png"/>'.html_safe,'<img src="/images/icon_attachment.png"/>'.html_safe], :sort_by=>'transfers.datum,transfers.seq', :width=>20},
    'documents_icons_dropable' => { :label=> ['<img src="/images/icon_attachment.png"/>'.html_safe,'<img src="/images/icon_attachment.png"/>'.html_safe], :sort_by=>'transfers.datum,transfers.seq', :width=>20},
    'documents_links'   => { :label=> ['dokumenty','documents'], :sort_by=>'transfers.datum,transfers.seq,transfers.popis', :class=>'dim'},
    'documents_urls'    => { :label=> ['url na dokumenty','documents urls'], :class=>'dim'},
    'flipping_arrow'    => { :label=> ['',''], :width=>5},
    'popis'             => { :label=> ['popis transakce','transaction details'], :width=>'*'},
    'popis_vendor'      => { :label=> ['popis transakce','transaction details'], :sort_by=>'transfers.popis', :width=>'*'},
    'popis_vendor_link' => { :label=> ['popis transakce','transaction details'], :sort_by=>'transfers.popis', :width=>'*', :class=>'hide_link'},    
    'poradi'            => { :label=> ['poř','#'], :class=>'dim', :width=>10},
    'rarrow'            => { :label=> ['',''], :width=>5},
    'seq'               => { :label=> ['č.','#'], :class=>'dim alignright', :width=>5, :sort_by=>'transfers.seq'},
    'seq2'              => { :label=> ['č2.','#'], :class=>'dim alignright', :width=>5},
    'star'              => { :label=> ['',''], :width=>5},
    'hash_reconciled'   => { :label=> ['',''], :width=>5},
    'vendor'            => { :label=> ['protistrana','vendor']},
    'cislouctu'         => { :label=> ['číslo účtu','account no.'], :class=>'dim alignright'},
    'cislouctu_prefix'  => { :label=> ['prefix č.ú.','acc. prefix'], :class=>'alignright'},
    'my_account'        => { :label=> ['my_account','my_account'], :sort_by=>'my_account.seq'},
    'foreign_account'   => { :label=> ['foreign_account','foreign_account'], :sort_by=>'my_account.seq'},
    'my_amount'         => { :label=> ['my_amount','my_amount'], :sort_by=>'my_account.seq'},
    'my_amount_value'   => { :label=> ['částka','amount'],  :class=>'alignright' },
    'my_amount_currency'=> { :label=> ['měna','curr'] },
    'amount_currencies' => { :label=> ['měny','curr'] },
    'amount_value_or_amount' => { :label=> ['částka','amount'],  :class=>'alignright' },
    'my_amount_value_or_amount' => { :label=> ['částka','amount'],  :class=>'alignright' },
    'toggle_select'     => { :label=> ['ozn','sel'], :class=>'bigger', :width=>40 },
    'line_number'       => { :label=> ['#','#'], :width=>5 },
    'ks'                => { :label=> ['KS','CS'] },
    'vs'                => { :label=> ['VS','VS'], :class=>'dim'},
    'ss'                => { :label=> ['SS','SS'] },
    'seq_clone_link'    => { :label=> ['klon','clone'], :class=>'dim alignright', :width=>5},
    'tag_list'          => { :label=> ['tagy','tags'], :width=>75},
    'tag_links'         => { :label=> ['tagy','tags'], :width=>75},
    'edit_popis'        => { :label=> ['popis transakce','transaction details'], :width=>'*', :editable=>true},
    nil               => {}
  }

  def self.clean_two_lines(show_balance=false)
    return [
      ['datum_seq','seq2','popis_vendor_link','amount_rich','star',show_balance ? 'balance_rich':'blank', 'documents_icons_dropable', 'actions','toggle_select'].collect{|cname| Column.new(cname)},
      ['blank','seq','accounts',show_balance ? 'balance_rich' : 'blank', 'blank', 'blank', 'blank', 'blank', 'blank'].collect{|cname| Column.new(cname)}
    ]
  end
  
  # usage : Column.by_name('seq','datum','popis') nebo  Column.by_name(['seq','popis'],['datum','accounts']) 
  def self.by_name(*colnames)
    result = Column.by_name_private(*colnames)
    result = result.first unless colnames.size>1
    return result
  end
  def self.by_name_private(*colnames)
    if colnames.first.is_a?(Array)
      colnames.collect{|cols| Column.by_name_private(*cols)}
    else
      colnames.collect{|cname| Column.new(cname)}
    end
  end

  def initialize(id)
    @id=id
    raise "Column '#{@id}' does not exist! Available columns: "+@@columns.keys.compact.join(', ') if @@columns[@id].nil?
  end
  def id
    @id
  end
  def label
    @@columns[@id].andand[:label].andand[$language_index]
  end
  def label_or_nbsp
    r = label
    if r.empty? then r = ' ' end
    r
  end
  def class_tag
    if html_class
      "class=\"#{html_class} col_#{@id}\"".html_safe
    else
      "class=\"col_#{@id}\"".html_safe
    end
  end
  def html_class
    @@columns[@id].andand[:class]
  end
  def sort_column
    (@@columns[@id].andand[:sort_by]) || @id
  end
  def width_html_attribute
    if !@@columns[@id].nil? &&  (w=@@columns[@id][:width])
      "width=\"#{w}\""
    else
      ''
    end
  end
  def width_html_style_attribute
    if !@@columns[@id].nil? &&  (w=@@columns[@id][:width])
      if w=='*' then w='auto' else w = w.to_s+'px' end
      "style=\"width:#{w}\""
    else
      ''
    end
  end
end
